// *********** const.h ***********
// Internal and The Bat provided constants
#ifndef CONST_H
#define CONST_H

#pragma pack(1)

namespace internal_const
{
    const unsigned max_filename_length=255;
};

// here comes TheBat (tm) provided constants

namespace crc32_const
{
    const int CRC32_POLY      = 0xEDB88320ul;          // Generator polynomial number
    const int CRC32_INIT      = 0xFFFFFFFFul;          // Initial CRC value for calculation
    const int CRC32_TEST      = 0xDEBB20E3ul;          // Result to test for at receiver
}

namespace thebat_const
{
      const int	aatName         = -1;
      const int	aatFirstName    = -2;
      const int	aatLastName     = -3;
      const int	aatMiddleName   = -4;
      const int	aatGroup        = -5;
      const int	aatCheck        = -6;
      const int	aatHandle       = -7;
      const int	aatMainEmailIdx = -8;
      const int	aatSex          = -9;
      const int	aatTemplateOpts = -10;
      const int	aatBCCSecondary = -11;

      const int	aatEnd          = -90;

      const int	aatPhoto        = -91;
      const int	aatCert         = -92;
      const int	aatHasTemplate  = -93;

      const int	aatEmails       = -99;
      const int	aatEmail        = -100;
      const int	aatuserSMIMECertificate = -101;
      const int	aatuserPKCS12   =-102;
      const int	aatCACertificate=-103;
      const int	aatUserCertificate=-104;
      //~~~~~~~~~~~~~~~~~~
      const int	aatMinAttr      = -11;

      const int	aatDName        = -30;
      const int	aatHost         = -31;
      const int	aatTimeStamp    = -32;

      const int	aatInvalidAttr  = aatMinAttr-1;

      const int	aatHomeAddr    = 0;
      const int	aatHomeCity    = 1;
      const int	aatHomeState   = 2;
      const int	aatHomeZIP     = 3;
      const int	aatHomeCountry = 4;
      const int	aatHomePhone   = 5;
      const int	aatHomeFax     = 6;
      const int	aatHomeMobile  = 7;
      const int	aatHomePage    = 8;
      const int	aatBusCompany  = 9;
      const int	aatBusAddr     = 10;
      const int	aatBusCity     = 11;
      const int	aatBusState    = 12;
      const int	aatBusZIP      = 13;
      const int	aatBusCountry  = 14;
      const int	aatBusJob      = 15;
      const int	aatBusDept     = 16;
      const int	aatBusOffice   = 17;
      const int	aatBusPhone    = 18;
      const int	aatBusFax      = 19;
      const int	aatBusPager    = 20;
      const int	aatBusPage     = 21;
      const int	aatMemo        = 22;
      const int	aatTemplate    = 23;
      const int	aatReply       = 24;
      const int	aatForward     = 25;
      const int	aatBirthday    = 26;
      const int	aatNamePrefix  = 27;
      const int	aatNameSuffix  = 28;
      const int	aatCharset     = 29;
      const int	aatX509Subjs   = 30;
      const int	aatX509Emails  = 31;
      const int	aatX509IsrSNs  = 32;
      const int	aatDBID        = 33;
      //{~~~}
      const int	aatMaxAttr     = 33;

      const int	ADDR_ACTION_ADD = 0x01;
      const int	ADDR_ACTION_DEL = 0x02;
      const int	ADDR_ACTION_MOD = 0x03;

      const int	cAddrBaseSign   = 0x19988991;
      const int	cAddrDataSign   = 0x19744791;
      const int	cStreamSign     = -1974;
// what the fuck is this ???
//      const int	WMU_HideABEditor = WM_User + 101;

      const int	cDirAddBy       = 256;

      const int	xxtItem         = 0;
      const int	xxtGroup        = 1;
      const int	xxtControl      = 3;

      const int	ggaItems        = -1;
      const int	ggaName         = 0;
      const int	ggaHandle       = 1;
      const int	ggaTemplate     = 2;
      const int	ggaReply        = 3;
      const int	ggaForward      = 4;
      const int	ggaMemo         = 5;
      const int	ggaOptions      = 6;
      const int	ggaCharset      = 7;
      //~~~~~~~~~~~~~~~~~
      const int	ggaMaxAttr      = 7;
      const int	ggaEnd          = -10;

      const int	ggpFavourite    = 1;
      const int	ggpHide         = 2;
      const int	ggpTemplate     = 3;
      const int	ggpReply        = 4;
      const int	ggpForward      = 5;
      const int	ggpCharset      = 6;
      //~~~~~~~~~~~~~~~~~
      const int	ggpMax          = 6;

      const int	SORT_BY_HOST    = 1000;

      const int	abCaUndef         = 0;
      const int	abRegular         = 0;
      const int	abCaFirstConst    = 1;
      const int	abCaRoot          = 1;
      const int	abCaIntermed      = 2;
      const int	abCaLastConst     = 2;

      const int	CurCaRev          = 1;

// These are the properties of the address book file itself

      const int	CTL_ID_END       = -1;
      const int	CTL_ID_Name      = 0;
      const int	CTL_ID_Memo      = 1;
      const int	CTL_ID_LDAP      = 2;
      const int	CTL_ID_LDAPSRV   = 3;
      const int	CTL_ID_LDAPSec   = 4;
      const int	CTL_ID_LDAPUser  = 5;
      const int	CTL_ID_LDAPPwd   = 6;
      const int	CTL_ID_LDAPSSL   = 7;
      const int	CTL_ID_LDAPPort  = 8;
      const int	CTL_ID_LDAPSize  = 9;
      const int	CTL_ID_LDAPBase  = 10;
      const int	CTL_ID_LDAPTime  = 11;
      const int	CTL_ID_CA        = 12;
      const int	CTL_ID_LDAPUnicode = 13;
      const int	CTL_ID_UID       = 14;
      const int	CTL_ID_CA_REV    = 15;
}
#endif


